# Create Cluster

To create a Network File Storage cluster via the API, perform a POST request with the name and description of the cluster.

{% hint style="warning" %}
**Important:** The user privilege for accessing and managing Network File Storage is not effective yet. Any user with an active token will be granted access to the service management independent of the privilege setting. The group privilege will be added to the application with an upcoming release and the documentation will be updated accordingly.
{% endhint %}

## Endpoint

Use the regional endpoints to create a cluster:

* Berlin, Germany: `https://nfs.de-txl.ionos.com`
* Frankfurt, Germany: `https://nfs.de-fra.ionos.com`
* Paris, France: `https://nfs.fr-par.ionos.com`
* London, Great Britain: `https://nfs.gb-lhr.ionos.com`
* Logroño, Spain: `https://nfs.es-vit.ionos.com`
* Las Vegas, United States: `https://nfs.us-las.ionos.com`
* Newark, United States: `https://nfs.us-ewr.ionos.com`
* Lenexa, United States: `https://nfs.us-mci.ionos.com`

The region 'Worcester, GB' will follow shortly.

## Request

{% hint style="info" %}
**Note:** The following request contains sample values. Remember to replace them with the relevant information.
{% endhint %}

```json
curl -X 'POST' \
  'https://nfs.de-txl.ionos.com/clusters' \
  -H 'accept: application/json' \
  -H 'Content-Type: application/json' \
  -d '{
  "metadata": {},
  "properties": {
    "name": "Cluster 1",
    "connections": [
      {
        "datacenterId": "123e4567-e89b-12d3-a456-426614174001",
        "lan": "1",
        "ipAddress": "10.254.64.1/24"
      }
    ],
    "nfs": {
      "minVersion": "4.2"
    },
    "size": 8
  }
}'
```

{% tabs %}
{% tab title="Request Header Parameters" %}
To make authenticated requests to the API, the following fields are mandatory in the request header:

| Header Parameters | Required |  Type  | Description                                                                                                                                                                                                        |
| ----------------- | :------: | :----: | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| `Authorization`   |    yes   | string | You can use `Basic Authentication` or a `Bearer token`. For more information, see [Authentication](/cloud/~/revisions/UIHN5vc23LyGCaurOi2f/storage-and-backup/network-file-storage/api-how-tos.md#authentication). |
| `Content-Type`    |    yes   | string | Set this to `application/json`.                                                                                                                                                                                    |
| {% endtab %}      |          |        |                                                                                                                                                                                                                    |

{% tab title="Request Body Parameters" %}
Below is the list of mandatory body parameters:

| Body Parameters | Type   | Description                                                                                                                             | Example                                |
| --------------- | ------ | --------------------------------------------------------------------------------------------------------------------------------------- | -------------------------------------- |
| `name`          | string | The human-readable name of your cluster.                                                                                                | `NFS cluster`                          |
| `datacenterId`  | string | The ID of the data center where the NFS cluster is located in.                                                                          | `e69b22a5-8fee-56b1-b6fb-4a07e4205ead` |
| `lan`           | string | The LAN to which the NFS cluster should be connected.                                                                                   | `1`                                    |
| `ipAddress`     | string | The IP address and prefix of the NFS cluster. The IP address can be either IPv4 or IPv6. The IP address must include the CIDR notation. | `10.254.64.1/24`                       |
| {% endtab %}    |        |                                                                                                                                         |                                        |
| {% endtabs %}   |        |                                                                                                                                         |                                        |

## Response

A **201** message confirms that the cluster creation is successful.

````json
{
  "id": "e69b22a5-8fee-56b1-b6fb-4a07e4205ead",
  "type": "cluster",
  "href": "/clusters/e69b22a5-8fee-56b1-b6fb-4a07e4205ead",
  "metadata": {
    "createdDate": "2020-12-10T13:37:50+01:00",
    "createdBy": "ionos:identity:::users/87f9a82e-b28d-49ed-9d04-fba2c0459cd3",
    "createdByUserId": "87f9a82e-b28d-49ed-9d04-fba2c0459cd3",
    "lastModifiedDate": "2020-12-11T13:37:50+01:00",
    "lastModifiedBy": "ionos:identity:::users/87f9a82e-b28d-49ed-9d04-fba2c0459cd3",
    "lastModifiedByUserId": "87f9a82e-b28d-49ed-9d04-fba2c0459cd3",
    "resourceURN": "ionos:<product>:<location>:<contract>:<resource-path>",
    "status": "AVAILABLE",
    "statusMessage": null
  },
  "properties": {
    "name": "Cluster 1",
    "connections": [
      {
        "datacenterId": "123e4567-e89b-12d3-a456-426614174001",
        "lan": "1",
        "ipAddress": "10.254.64.1/24"
      }
    ],
    "nfs": {
      "minVersion": "4.2"
    },
    "size": 8
  }
} ```
````


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.ionos.com/cloud/~/revisions/UIHN5vc23LyGCaurOi2f/storage-and-backup/network-file-storage/api-how-tos/create-cluster.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
